JRE="JRE-19.0.1"

Set fs = WScript.CreateObject("Scripting.FileSystemObject")
Set WshShell = WScript.CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

Title="Install/Update TRAD"
Message0="Please first terminate TRAD (javaw.exe)"
Message1="Install Directory"
Message2="Install/Update Successful."
Message3="fixed-width-font install failed, check internet access"
Message4="JRE install failed, check internet access"
Message5="Download and Unzip fixed-width-font"
Message6="Download and Unzip local JRE"
WaitMessage="Please Wait"

Locale=getLocale()
If Locale=1041 Then 
   Title="TRAD ̃CXg[EAbvf[g"
   Message0="܂ TRAD (javaw.exe) IĂ"
   Message1="CXg[̎w"
   Message2="CXg["
   Message3="fixed-width-font ̃CXg[ɎsCC^[lbgANZX𒲂ׂĂ"
   Message4="JRE ̃CXg[ɎsCC^[lbgANZX𒲂ׂĂ"
   Message5="fixed-width-font _E[h"
   Message6="TRADp JRE _E[h"
   WaitMessage="҂"
End If

'check if TRAD is running 
 temp=WshShell.ExpandEnvironmentStrings("%TEMP%\out.txt")
 WshShell.RUN "cmd /c tasklist.exe > " & temp, 0, True
  strOutput = fso.OpenTextFile(temp).ReadAll()
  fso.DeleteFile temp
   RtnCode=InStr(StrOutput, "javaw.exe")
    If not RtnCode = 0 Then
       MsgBox Message0
       WScript.Quit
    End If


' set default install directory
HomeDir=WshShell.expandEnvironmentStrings("%HOMEDRIVE%%HOMEPATH%\")
InstallDir=HomeDir & "TRAD.public"

' set current directory
scriptPath = WScript.ScriptFullName
scriptPath = left(scriptPath,len(scriptPath)-len(WScript.ScriptName))
scriptDir=Left(scriptPath, Len(scriptPath)-1)
WshShell.CurrentDirectory=scriptDir

' ask install directory
InstallDir=InputBox( Message1,Title, InstallDir )
If InstallDir="" Then WScript.Quit

' copy
logfile=ScriptPath & "log.txt"
cmd="ROBOCOPY " &  """" & ScriptDir & """" & " " & """" & InstallDir & """" & " /PURGE /R:0 /XX /MIR /MT /XF log.txt install.vbs /LOG:" & """" & logfile & """"
r=WshShell.Run (cmd , 0, TRUE )
If r >7 Then 
	MsgBox "RoboCopy error=" & r & ", exit now"
	Wscript.Quit
End If

' set  .TRADhistory attribute
cmd="attrib -h -a "+InstallDir+"\conf\.TRADhistory"
r=WshShell.Run(cmd, 0, TRUE)
If r >7 Then 
	MsgBox ".TRADhistory attribute change error=" & r & ", exit now"
	Wscript.Quit
End If


' install fixed-width-font if not
If not fs.FolderExists(InstallDir & "\fixed-width-font") Then
  r=0
  r=WshShell.Popup(WaitMessage, 2, Message5)
  If r=1 or r=-1 Then
    call download( "datascience.jp/TRAD/Download", "fixed-width-font.zip", InstallDir)   
  End If
End If


' install local JRE if not
If not fs.FolderExists(InstallDir & "\" & JRE) Then
   If myExists(fs.GetFolder(InstallDir), "JRE") Then
      fs.DeleteFolder(InstallDir & "\JRE*")
   End If
  r=0
  r=WshShell.Popup(WaitMessage, 2, Message6)
  If r=1 or r=-1 Then
    call download("datascience.jp/TRAD/Download/Windows", JRE+".zip", InstallDir)
  End If
End If


'create a shortcut
TargetPath = InstallDir & "\TRAD.exe" 
DesktopPath = WshShell.SpecialFolders("Desktop")
link = DesktopPath + "\TRAD.lnk"
Set shortCut = WshShell.CreateShortcut(link)
shortCut.TargetPath = TargetPath
shortCut.Save


' set DandD icon
Classes="HKCU\SOFTWARE\Classes\" 
WshShell.RegWrite Classes & ".dad\", "DandDInstance", "REG_SZ"
WshShell.RegWrite Classes & "DandDInstance\DefaultIcon\", InstallDir & "\icons\DandD.ico", "REG_SZ"
WshShell.RegWrite Classes & "DandDInstance\shell\open\command\", """" & TargetPath & """ " & """" & "%1" & """"

' set TRAD icon
WshShell.RegWrite Classes & ".TRAD\", "TRAD", "REG_SZ"
WshShell.RegWrite Classes & "TRAD\DefaultIcon\", InstallDir & "\icons\TRAD.ico", "REG_SZ"

' set TRAD open
WshShell.RegWrite Classes & "TRAD\shell\open\command\", """" & TargetPath & """ " & """" & "%1" & """"
WshShell.RegWrite Classes & "Applications\TRAD.exe\shell\open\command\", """" & TargetPath & """ " & """" & "%1" & """" 


'check install
exist1= fs.FolderExists(InstallDir & "\fixed-width-font")
exist2= fs.FolderExists(InstallDir & "\" & JRE) 

If not exist1 Then 
   		MsgBox Message3
End If

If not exist2 Then 
   		MsgBox Message4
End If


If not exist1 or not exist2 Then

Wscript.Quit

End If 


'finish
x=MsgBox( Message2,, "TRAD")



Sub download(sourceURL, zipFileName, destinationDir)

	Set fso = CreateObject("Scripting.FileSystemObject")
	sourceFile = fso.GetAbsolutePathName(zipFileName)
	destFolder = fso.GetAbsolutePathName(destinationDir)

	' get Zip file
	dim xHttp: Set xHttp = createobject("Microsoft.XMLHTTP")
	dim bStrm: Set bStrm = createobject("Adodb.Stream")
	xHttp.Open "GET", "https://" & sourceURL & "/" & zipFileName, False
	xHttp.Send

	with bStrm
	  .type = 1 '//binary
  	  .open
  	  .write xHttp.responseBody
  	  .savetofile sourceFile, 2 '//overwrite
	end with

	'unzip and install
	Set objShell = CreateObject("Shell.Application")
	Set FilesInZip=objShell.NameSpace(sourceFile).Items()
              objShell.NameSpace(destFolder).copyHere FilesInZip, 16
              fso.DeleteFile sourceFile, True
End Sub

Function myExists( sParent, sTarget )
     Dim sf, ss
     Set sf = sParent.SubFolders
      For Each ss in sf
      If Left( ss.Name, len(sTarget)) = sTarget Then
	myExists = True
	Exit Function
	End If
	Next
	myEXists = False
End Function


















'' SIG '' Begin signature block
'' SIG '' MIIkjQYJKoZIhvcNAQcCoIIkfjCCJHoCAQExCzAJBgUr
'' SIG '' DgMCGgUAMGcGCisGAQQBgjcCAQSgWTBXMDIGCisGAQQB
'' SIG '' gjcCAR4wJAIBAQQQTvApFpkntU2P5azhDxfrqwIBAAIB
'' SIG '' AAIBAAIBAAIBADAhMAkGBSsOAwIaBQAEFM/8NqHzbbPf
'' SIG '' l+2zChNl7sqtW/xcoIIR7jCCBW8wggRXoAMCAQICEEj8
'' SIG '' k7RgVZSNNqfJionWlBYwDQYJKoZIhvcNAQEMBQAwezEL
'' SIG '' MAkGA1UEBhMCR0IxGzAZBgNVBAgMEkdyZWF0ZXIgTWFu
'' SIG '' Y2hlc3RlcjEQMA4GA1UEBwwHU2FsZm9yZDEaMBgGA1UE
'' SIG '' CgwRQ29tb2RvIENBIExpbWl0ZWQxITAfBgNVBAMMGEFB
'' SIG '' QSBDZXJ0aWZpY2F0ZSBTZXJ2aWNlczAeFw0yMTA1MjUw
'' SIG '' MDAwMDBaFw0yODEyMzEyMzU5NTlaMFYxCzAJBgNVBAYT
'' SIG '' AkdCMRgwFgYDVQQKEw9TZWN0aWdvIExpbWl0ZWQxLTAr
'' SIG '' BgNVBAMTJFNlY3RpZ28gUHVibGljIENvZGUgU2lnbmlu
'' SIG '' ZyBSb290IFI0NjCCAiIwDQYJKoZIhvcNAQEBBQADggIP
'' SIG '' ADCCAgoCggIBAI3nlBIiBCR0Lv8WIwKSirauNoWsR9Qj
'' SIG '' kSs+3H3iMaBRb6yEkeNSirXilt7Qh2MkiYr/7xKTO327
'' SIG '' toq9vQV/J5trZdOlDGmxvEk5mvFtbqrkoIMn2poNK1Dp
'' SIG '' S1uzuGQ2pH5KPalxq2Gzc7M8Cwzv2zNX5b40N+OXG139
'' SIG '' HxI9ggN25vs/ZtKUMWn6bbM0rMF6eNySUPJkx6otBKvD
'' SIG '' aurgL6en3G7X6P/aIatAv7nuDZ7G2Z6Z78beH6kMdrMn
'' SIG '' IKHWuv2A5wHS7+uCKZVwjf+7Fc/+0Q82oi5PMpB0RmtH
'' SIG '' NRN3BTNPYy64LeG/ZacEaxjYcfrMCPJtiZkQsa3bPizk
'' SIG '' qhiwxgcBdWfebeljYx42f2mJvqpFPm5aX4+hW8udMIYw
'' SIG '' 6AOzQMYNDzjNZ6hTiPq4MGX6b8fnHbGDdGk+rMRoO7Hm
'' SIG '' ZzOatgjggAVIQO72gmRGqPVzsAaV8mxln79VWxycVxrH
'' SIG '' eEZ8cKqUG4IXrIfptskOgRxA1hYXKfxcnBgr6kX1773V
'' SIG '' Z08oXgXukEx658b00Pz6zT4yRhMgNooE6reqB0acDZM6
'' SIG '' CWaZWFwpo7kMpjA4PNBGNjV8nLruw9X5Cnb6fgUbQMqS
'' SIG '' NenVetG1fwCuqZCqxX8BnBCxFvzMbhjcb2L+plCnuHu4
'' SIG '' nRU//iAMdcgiWhOVGZAA6RrVwobx447sX/TlAgMBAAGj
'' SIG '' ggESMIIBDjAfBgNVHSMEGDAWgBSgEQojPpbxB+zirynv
'' SIG '' gqV/0DCktDAdBgNVHQ4EFgQUMuuSmv81lkgvKEBCcCA2
'' SIG '' kVwXheYwDgYDVR0PAQH/BAQDAgGGMA8GA1UdEwEB/wQF
'' SIG '' MAMBAf8wEwYDVR0lBAwwCgYIKwYBBQUHAwMwGwYDVR0g
'' SIG '' BBQwEjAGBgRVHSAAMAgGBmeBDAEEATBDBgNVHR8EPDA6
'' SIG '' MDigNqA0hjJodHRwOi8vY3JsLmNvbW9kb2NhLmNvbS9B
'' SIG '' QUFDZXJ0aWZpY2F0ZVNlcnZpY2VzLmNybDA0BggrBgEF
'' SIG '' BQcBAQQoMCYwJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3Nw
'' SIG '' LmNvbW9kb2NhLmNvbTANBgkqhkiG9w0BAQwFAAOCAQEA
'' SIG '' Er+h74t0mphEuGlGtaskCgykime4OoG/RYp9UgeojR9O
'' SIG '' IYU5o2teLSCGvxC4rnk7U820+9hEvgbZXGNn1EAWh0SG
'' SIG '' cirWMhX1EoPC+eFdEUBn9kIncsUj4gI4Gkwg4tsB981G
'' SIG '' TyaifGbAUTa2iQJUx/xY+2wA7v6Ypi6VoQxTKR9v2Bmm
'' SIG '' T573rAnqXYLGi6+Ap72BSFKEMdoy7BXkpkw9bDlz1AuF
'' SIG '' OSDghRpo4adIOKnRNiV3wY0ZFsWITGZ9L2POmOhp36w8
'' SIG '' qF2dyRxbrtjzL3TPuH7214OdEZZimq5FE9p/3Ef738NS
'' SIG '' n+YGVemdjPI6YlG87CQPKdRYgITkRXta2DCCBhowggQC
'' SIG '' oAMCAQICEGIdbQxSAZ47kHkVIIkhHAowDQYJKoZIhvcN
'' SIG '' AQEMBQAwVjELMAkGA1UEBhMCR0IxGDAWBgNVBAoTD1Nl
'' SIG '' Y3RpZ28gTGltaXRlZDEtMCsGA1UEAxMkU2VjdGlnbyBQ
'' SIG '' dWJsaWMgQ29kZSBTaWduaW5nIFJvb3QgUjQ2MB4XDTIx
'' SIG '' MDMyMjAwMDAwMFoXDTM2MDMyMTIzNTk1OVowVDELMAkG
'' SIG '' A1UEBhMCR0IxGDAWBgNVBAoTD1NlY3RpZ28gTGltaXRl
'' SIG '' ZDErMCkGA1UEAxMiU2VjdGlnbyBQdWJsaWMgQ29kZSBT
'' SIG '' aWduaW5nIENBIFIzNjCCAaIwDQYJKoZIhvcNAQEBBQAD
'' SIG '' ggGPADCCAYoCggGBAJsrnVP6NT+OYAZDasDP9X/2yFNT
'' SIG '' GMjO02x+/FgHlRd5ZTMLER4ARkZsQ3hAyAKwktlQqFZO
'' SIG '' GP/I+rLSJJmFeRno+DYDY1UOAWKA4xjMHY4qF2p9YZWh
'' SIG '' hbeFpPb09JNqFiTCYy/Rv/zedt4QJuIxeFI61tqb7/fo
'' SIG '' XT1/LW2wHyN79FXSYiTxcv+18Irpw+5gcTbXnDOsrSHV
'' SIG '' JYdPE9s+5iRF2Q/TlnCZGZOcA7n9qudjzeN43OE/TpKF
'' SIG '' 2dGq1mVXn37zK/4oiETkgsyqA5lgAQ0c1f1IkOb6rGnh
'' SIG '' WqkHcxX+HnfKXjVodTmmV52L2UIFsf0l4iQ0UgKJUc2R
'' SIG '' GarhOnG3B++OxR53LPys3J9AnL9o6zlviz5pzsgfrQH4
'' SIG '' lrtNUz4Qq/Va5MbBwuahTcWk4UxuY+PynPjgw9nV/35g
'' SIG '' RAhC3L81B3/bIaBb659+Vxn9kT2jUztrkmep/aLb+4xJ
'' SIG '' bKZHyvahAEx2XKHafkeKtjiMqcUf/2BG935A591Gsllv
'' SIG '' WwIDAQABo4IBZDCCAWAwHwYDVR0jBBgwFoAUMuuSmv81
'' SIG '' lkgvKEBCcCA2kVwXheYwHQYDVR0OBBYEFA8qyyCHKLjs
'' SIG '' b0iuK1SmKaoXpM0MMA4GA1UdDwEB/wQEAwIBhjASBgNV
'' SIG '' HRMBAf8ECDAGAQH/AgEAMBMGA1UdJQQMMAoGCCsGAQUF
'' SIG '' BwMDMBsGA1UdIAQUMBIwBgYEVR0gADAIBgZngQwBBAEw
'' SIG '' SwYDVR0fBEQwQjBAoD6gPIY6aHR0cDovL2NybC5zZWN0
'' SIG '' aWdvLmNvbS9TZWN0aWdvUHVibGljQ29kZVNpZ25pbmdS
'' SIG '' b290UjQ2LmNybDB7BggrBgEFBQcBAQRvMG0wRgYIKwYB
'' SIG '' BQUHMAKGOmh0dHA6Ly9jcnQuc2VjdGlnby5jb20vU2Vj
'' SIG '' dGlnb1B1YmxpY0NvZGVTaWduaW5nUm9vdFI0Ni5wN2Mw
'' SIG '' IwYIKwYBBQUHMAGGF2h0dHA6Ly9vY3NwLnNlY3RpZ28u
'' SIG '' Y29tMA0GCSqGSIb3DQEBDAUAA4ICAQAG/4Lhd2M2bnuh
'' SIG '' FSCbE/8E/ph1RGHDVpVx0ZE/haHrQECxyNbgcv2FymQ5
'' SIG '' PPmNS6Dah66dtgCjBsULYAor5wxxcgEPRl05pZOzI3IE
'' SIG '' Gwwsepp+8iGsLKaVpL3z5CmgELIqmk/Q5zFgR1TSGmxq
'' SIG '' oEEhk60FqONzDn7D8p4W89h8sX+V1imaUb693TGqWp3T
'' SIG '' 32IKGfIgy9jkd7GM7YCa2xulWfQ6E1xZtYNEX/ewGnp9
'' SIG '' ZeHPsNwwviJMBZL4xVd40uPWUnOJUoSiugaz0yWLODRt
'' SIG '' Qxs5qU6E58KKmfHwJotl5WZ7nIQuDT0mWjwEx7zSM7fs
'' SIG '' 9Tx6N+Q/3+49qTtUvAQsrEAxwmzOTJ6Jp6uWmHCgrHW4
'' SIG '' dHM3ITpvG5Ipy62KyqYovk5O6cC+040Si15KJpuQ9VJn
'' SIG '' bPvqYqfMB9nEKX/d2rd1Q3DiuDexMKCCQdJGpOqUsxLu
'' SIG '' COuFOoGbO7Uv3RjUpY39jkkp0a+yls6tN85fJe+Y8voT
'' SIG '' nbPU1knpy24wUFBkfenBa+pRFHwCBB1QtS+vGNRhsceP
'' SIG '' 3kSPNrrfN2sRzFYsNfrFaWz8YOdU254qNZQfd9O/VjxZ
'' SIG '' 2Gjr3xgANHtM3HxfzPYF6/pKK8EE4dj66qKKtm2DTL1K
'' SIG '' FCg/OYJyfrdLJq1q2/HXntgr2GVw+ZWhrWgMTn8v1SjZ
'' SIG '' sLlrgIfZHDCCBlkwggTBoAMCAQICEDxCloWJBEv5joxs
'' SIG '' ZT/3Id4wDQYJKoZIhvcNAQEMBQAwVDELMAkGA1UEBhMC
'' SIG '' R0IxGDAWBgNVBAoTD1NlY3RpZ28gTGltaXRlZDErMCkG
'' SIG '' A1UEAxMiU2VjdGlnbyBQdWJsaWMgQ29kZSBTaWduaW5n
'' SIG '' IENBIFIzNjAeFw0yMjA4MDUwMDAwMDBaFw0yNDA4MDQy
'' SIG '' MzU5NTlaMHAxCzAJBgNVBAYTAkpQMREwDwYDVQQIDAhL
'' SIG '' YW5hZ2F3YTEmMCQGA1UECgwdREFUQSBTQ0lFTkNFIENP
'' SIG '' TlNPUlRJVU0sIExURC4xJjAkBgNVBAMMHURBVEEgU0NJ
'' SIG '' RU5DRSBDT05TT1JUSVVNLCBMVEQuMIICIjANBgkqhkiG
'' SIG '' 9w0BAQEFAAOCAg8AMIICCgKCAgEAnJwI0e5e4+GgvtTS
'' SIG '' j6wSRBeQL5u7ofzQUfYJ2/7mwJ1Gzi+7/FdsXKYbczP0
'' SIG '' pg+zF3dq3LgHo8iSTfoNRlAU4uMiPbmdXIAURufiCeom
'' SIG '' 2hXBOvesLwjebm3kyfpU5GW52q7Ih9hgb7cmCOYn3FqO
'' SIG '' b2R1Mp4FvZLDE9do8/XFA1sJqGaleVq57MkrNEbFs2GM
'' SIG '' DRW9CtC2LZyhGqcxfF3/6/OVH2LEW4oUhJ1pSMsfCZIU
'' SIG '' 1x14aZVUBAcFOmBZBSUlUwwfrBKf8vk2rod50lhmH5jM
'' SIG '' gADAMpNITnay0lyswS1ynd6oSwaiuz1GpMQz4sff8gr+
'' SIG '' AVUsL5cbXw7JzbA5i42w5MbswWIHClKDG4uacZZU4DTU
'' SIG '' pVNrAw4fvnhlQCYDcJUgj5ulPbQhdLriDLstMuta6B6B
'' SIG '' gJWyyA1xxlns8Z3ah4hOEyjhk3QhNKbGrUpxj2s2KcZ8
'' SIG '' zK8ETkG05JEA+/de8lrN1lT2OmZobuZv1cXQ8N0jJet9
'' SIG '' tesgXXAHXC2y4oY5e+WbD8bek736pl0L+fMDQbSX/hP7
'' SIG '' Hxm1w3Vv6OSU50BLlwLmHepwt0mwzloB4HZv76oL9ShH
'' SIG '' o4K67Psrw48N0KsS7FakwIqSuO+6UNIHa2lTVIq0UhZM
'' SIG '' xtTVMPYW/d8rEbEmV2VD4geTONxP1ZabSW55E9Wg4zvh
'' SIG '' ch90mM0CAwEAAaOCAYkwggGFMB8GA1UdIwQYMBaAFA8q
'' SIG '' yyCHKLjsb0iuK1SmKaoXpM0MMB0GA1UdDgQWBBTCJID2
'' SIG '' CBLFz8JqKHdC6AjjU036HDAOBgNVHQ8BAf8EBAMCB4Aw
'' SIG '' DAYDVR0TAQH/BAIwADATBgNVHSUEDDAKBggrBgEFBQcD
'' SIG '' AzBKBgNVHSAEQzBBMDUGDCsGAQQBsjEBAgEDAjAlMCMG
'' SIG '' CCsGAQUFBwIBFhdodHRwczovL3NlY3RpZ28uY29tL0NQ
'' SIG '' UzAIBgZngQwBBAEwSQYDVR0fBEIwQDA+oDygOoY4aHR0
'' SIG '' cDovL2NybC5zZWN0aWdvLmNvbS9TZWN0aWdvUHVibGlj
'' SIG '' Q29kZVNpZ25pbmdDQVIzNi5jcmwweQYIKwYBBQUHAQEE
'' SIG '' bTBrMEQGCCsGAQUFBzAChjhodHRwOi8vY3J0LnNlY3Rp
'' SIG '' Z28uY29tL1NlY3RpZ29QdWJsaWNDb2RlU2lnbmluZ0NB
'' SIG '' UjM2LmNydDAjBggrBgEFBQcwAYYXaHR0cDovL29jc3Au
'' SIG '' c2VjdGlnby5jb20wDQYJKoZIhvcNAQEMBQADggGBAE1G
'' SIG '' X/7oVb/01A5wc2yPNtlkEuyeMWNKtnmusg1cTC7gj8TJ
'' SIG '' RfO6olJz0Hbo0rEy8uzUkjHvlIvzJkr2GXQ+pt3ZeSau
'' SIG '' 1wc5V7GQ7rtd+B2COiYDYSRcmmGbGGUI2xcWkZeVmw7c
'' SIG '' bU1YX0JWZV2iBVNV2yLf3w1CSrgyf6UawqX5KrUkczLf
'' SIG '' /b+N+4C+VtwSxCXTB4Y5JHfKE36ErFMygHGAagGQn2r+
'' SIG '' q2vLEufJw8JHvoyfztedIhN//0tZCtH137sHQYItJeLn
'' SIG '' alyqjk4cQIssdot37hWAciHdGY6O6d2APaIrPpgCVoCg
'' SIG '' liC1x+JYEunjFoo5mVfQta3h1HCVz6fPfvQhSqdVtHF7
'' SIG '' CNR5HHf+5eouEJGVoQsAeuipEds094vuhyik8blHVAvF
'' SIG '' 3S8i7YVDI2xAYDV+2/mbXufGClkf7bnw/vdLHSzTwC5D
'' SIG '' bce0VVqr2nd9BlEmMfgQ2dnjREbi/Dvg2PiOf7hF6lDZ
'' SIG '' CJvjmNs4nDiXPY6KyR6fftwIZzGCEgswghIHAgEBMGgw
'' SIG '' VDELMAkGA1UEBhMCR0IxGDAWBgNVBAoTD1NlY3RpZ28g
'' SIG '' TGltaXRlZDErMCkGA1UEAxMiU2VjdGlnbyBQdWJsaWMg
'' SIG '' Q29kZSBTaWduaW5nIENBIFIzNgIQPEKWhYkES/mOjGxl
'' SIG '' P/ch3jAJBgUrDgMCGgUAoHAwEAYKKwYBBAGCNwIBDDEC
'' SIG '' MAAwGQYJKoZIhvcNAQkDMQwGCisGAQQBgjcCAQQwHAYK
'' SIG '' KwYBBAGCNwIBCzEOMAwGCisGAQQBgjcCARUwIwYJKoZI
'' SIG '' hvcNAQkEMRYEFFXlyGk/jg6PYuk3gQGwT0yGVOwWMA0G
'' SIG '' CSqGSIb3DQEBAQUABIICACtW5jvvRl78oYGvZJ9k83Ot
'' SIG '' O2GSTj5aHyRiZDDvfM4MVxBtCX2qCjhyRyjK468cMlXE
'' SIG '' EPdcMRsiA6RVyntfvW/1JI6JRhtp22agqgIEv9CPBf8o
'' SIG '' 50Hc5EqNzsav+sYtJukzXXBRZJq6dQapOUjqRumC8onz
'' SIG '' NdroWyJSqbqTKPTeGbMxLr+TW0mzehWMh8M5z0x56XcS
'' SIG '' T1peXhW5ZpSExtXdmOdMgKWLypUj/iaiALMCMPAppzsN
'' SIG '' +dIbXFm3dpWod5gZ7TI5LruRldcZWqeZNHHl9IvaoDSq
'' SIG '' yxKD2oB28ZYCsnGOqf1cYksw0gTVBPvshq8691bcUDdM
'' SIG '' ezQBhc8/gVZTPSFdyvc3fmutbyU4tK0N69GCFQBHEy/B
'' SIG '' b/VgYB4NAqDCCYlbiQ1wO5gx77XUEQT+LdnD/xiCBQMb
'' SIG '' IoWfm4fQ9qsthsGpSQRBR4BKdzVXtYTPX4tgMrfTkoJW
'' SIG '' cwOl+JQh51iIn7PKhAAstnbT3QafxUhxBSwXjkhi8EYe
'' SIG '' En2J+GuZF2gl/bZDPWa75nYTU0nfMAcAyHk5cpMWFAbn
'' SIG '' qo4FvwiyVWF6voSLon8Iwd0ErMCnEPTbxGOuTQyAX0Qg
'' SIG '' dRNHQvgnUn1309rIuTapVR83WHYIoMFmnXkz4UYjv+pA
'' SIG '' O/Qk3f5kgGz0kI/G+ZcRyAM6MgXVDCieG3huAw/bD9Wh
'' SIG '' oYIPBjCCDwIGCisGAQQBgjcDAwExgg7yMIIO7gYJKoZI
'' SIG '' hvcNAQcCoIIO3zCCDtsCAQMxDTALBglghkgBZQMEAgEw
'' SIG '' ZwYLKoZIhvcNAQkQAQSgWARWMFQCAQEGDCsGAQQBgqkw
'' SIG '' AQMGATAhMAkGBSsOAwIaBQAEFJCUe/hE8wa7V+Oacgmh
'' SIG '' zlA6i0/XAggVmix6nSLIFBgPMjAyNDA1MTgxNDM2NTBa
'' SIG '' MAMCAQGgggwAMIIE/DCCAuSgAwIBAgIQWlqs6Bo1brRi
'' SIG '' ho1XfeA9xzANBgkqhkiG9w0BAQsFADBzMQswCQYDVQQG
'' SIG '' EwJVUzEOMAwGA1UECAwFVGV4YXMxEDAOBgNVBAcMB0hv
'' SIG '' dXN0b24xETAPBgNVBAoMCFNTTCBDb3JwMS8wLQYDVQQD
'' SIG '' DCZTU0wuY29tIFRpbWVzdGFtcGluZyBJc3N1aW5nIFJT
'' SIG '' QSBDQSBSMTAeFw0yNDAyMTkxNjE4MTlaFw0zNDAyMTYx
'' SIG '' NjE4MThaMG4xCzAJBgNVBAYTAlVTMQ4wDAYDVQQIDAVU
'' SIG '' ZXhhczEQMA4GA1UEBwwHSG91c3RvbjERMA8GA1UECgwI
'' SIG '' U1NMIENvcnAxKjAoBgNVBAMMIVNTTC5jb20gVGltZXN0
'' SIG '' YW1waW5nIFVuaXQgMjAyNCBFMTBZMBMGByqGSM49AgEG
'' SIG '' CCqGSM49AwEHA0IABKdhcvUw6XrEgxSWBULj3Oid25Rt
'' SIG '' 2TJvSmLLaLy3cmVATADvhyMryD2ZELwYfVwABUwivwzY
'' SIG '' d1mlWCRXUtcEsHyjggFaMIIBVjAfBgNVHSMEGDAWgBQM
'' SIG '' nRAljpqnG5mHQ88IfuG9gZD0zzBRBggrBgEFBQcBAQRF
'' SIG '' MEMwQQYIKwYBBQUHMAKGNWh0dHA6Ly9jZXJ0LnNzbC5j
'' SIG '' b20vU1NMLmNvbS10aW1lU3RhbXBpbmctSS1SU0EtUjEu
'' SIG '' Y2VyMFEGA1UdIARKMEgwPAYMKwYBBAGCqTABAwYBMCww
'' SIG '' KgYIKwYBBQUHAgEWHmh0dHBzOi8vd3d3LnNzbC5jb20v
'' SIG '' cmVwb3NpdG9yeTAIBgZngQwBBAIwFgYDVR0lAQH/BAww
'' SIG '' CgYIKwYBBQUHAwgwRgYDVR0fBD8wPTA7oDmgN4Y1aHR0
'' SIG '' cDovL2NybHMuc3NsLmNvbS9TU0wuY29tLXRpbWVTdGFt
'' SIG '' cGluZy1JLVJTQS1SMS5jcmwwHQYDVR0OBBYEFFBPJKzv
'' SIG '' tT5jEyMJkibsujqW5F0iMA4GA1UdDwEB/wQEAwIHgDAN
'' SIG '' BgkqhkiG9w0BAQsFAAOCAgEAmKCPAwCRvKvEZEF/QiHi
'' SIG '' v6tsIHnuVO7BWILqcfZ9lJyIyiCmpLOtJ5VnZ4hvm+GP
'' SIG '' 2tPuOpZdmfTYWdyzhhOsDVDLElbfrKMLiOXn9uwUJpa5
'' SIG '' fMZe3Zjoh+n/8DdnSw1MxZNMGhuZx4zeyqei91f1OhEU
'' SIG '' /7b2vnJCc9yBFMjY++tVKovFj0TKT3/Ry+Izdbb1gGXT
'' SIG '' zQQ1uVFy7djxGx/NG1VP/aye4OhxHG9FiZ3RM9oyAiPb
'' SIG '' EgjrnVCc+nWGKr3FTQDKi8vNuyLnCVHkiniL+Lz7H4fB
'' SIG '' gk163Llxi11Ynu5A/phpm1b+M2genvqo1+2r8iVLHrER
'' SIG '' gFGMUHEdKrZ/OFRDmgFrCTY6xnaPTA5/ursCqMK3q3/5
'' SIG '' 9uZaOsBZhZkaP9EuOW2p0U8Gkgqp2GNUjFoaDNWFoT/E
'' SIG '' coGDiTgN8VmQFgn0Fa4/3dOb6lpYEPBcjsWDdqUaxugS
'' SIG '' tY9aW/AwCal4lSN4otljbok8u31lZx5NVa4jK6N6upvk
'' SIG '' gyZ6osmbmIWr9DLhg8bI+KiXDnDWT0547gSuZLYUq+TV
'' SIG '' 6O/DhJZH5LVXJaeS1jjjZZqhK3EEIJVZl0xYV4H4Skvy
'' SIG '' 6hA2rUyFK3+whSNS52TJkshsxVCOPtvqA9ecPqZLwWBa
'' SIG '' IICG4zVr+GAD7qjWwlaLMd2ZylgOHI3Oit/0pVETqJHu
'' SIG '' tyYwggb8MIIE5KADAgECAhBtUhhwh+gjTYVgANCAj5NW
'' SIG '' MA0GCSqGSIb3DQEBCwUAMHwxCzAJBgNVBAYTAlVTMQ4w
'' SIG '' DAYDVQQIDAVUZXhhczEQMA4GA1UEBwwHSG91c3RvbjEY
'' SIG '' MBYGA1UECgwPU1NMIENvcnBvcmF0aW9uMTEwLwYDVQQD
'' SIG '' DChTU0wuY29tIFJvb3QgQ2VydGlmaWNhdGlvbiBBdXRo
'' SIG '' b3JpdHkgUlNBMB4XDTE5MTExMzE4NTAwNVoXDTM0MTEx
'' SIG '' MjE4NTAwNVowczELMAkGA1UEBhMCVVMxDjAMBgNVBAgM
'' SIG '' BVRleGFzMRAwDgYDVQQHDAdIb3VzdG9uMREwDwYDVQQK
'' SIG '' DAhTU0wgQ29ycDEvMC0GA1UEAwwmU1NMLmNvbSBUaW1l
'' SIG '' c3RhbXBpbmcgSXNzdWluZyBSU0EgQ0EgUjEwggIiMA0G
'' SIG '' CSqGSIb3DQEBAQUAA4ICDwAwggIKAoICAQCuURAT0vk8
'' SIG '' IKAghd7JUBxkyeH9xek0/wp/MUjoclrFXqhh/fGH91Fc
'' SIG '' +7fm0MHCE7A+wmOiqBj9ODrJAYGq3rm33jCnHSsCBNWA
'' SIG '' QYyoauLq8IjqsS1JlXL29qDNMMdwZ8UNzQS7vWZMDJ40
'' SIG '' JSGNphMGTIA2qn2bohGtgRc4p1395ESypUOaGvJ3t0FN
'' SIG '' L3BuKmb6YctMcQUF2sqooMzd89h0E6ujdvBDo6ZwNnWo
'' SIG '' xj7YmfWjSXg33A5GuY9ym4QZM5OEVgo8ebz/B+gyhyCL
'' SIG '' NNhh4Mb/4xvCTCMVmNYrBviGgdPZYrym8Zb84TQCmSuX
'' SIG '' 0JlLLa6WK1aO6qlwISbb9bVGh866ekKblC/XRP20gAu1
'' SIG '' CjvcYciUgNTrGFg8f8AJgQPOCc1/CCdaJSYwhJpSdheK
'' SIG '' OnQgESgNmYZPhFOC6IKaMAUXk5U1tjTcFCgFvvArXtK4
'' SIG '' azAWUOO1Y3fdldIBL6LjkzLUCYJNkFXqhsBVcPMuB0nU
'' SIG '' DWvLJfPimstjJ8lF4S6ECxWnlWi7OElVwTnt1GtRqeY9
'' SIG '' ydvvGLntU+FecK7DbqHDUd366UreMkSBtzevAc9aqoZP
'' SIG '' njVMjvFqV1pYOjzmTiVHZtAc80bAfFe5LLfJzPI6DntN
'' SIG '' yqobpwTevQpHqPDN9qqNO83r3kaw8A9j+HZiSw2AX5cG
'' SIG '' dQP0kG0vhzfgBwIDAQABo4IBgTCCAX0wEgYDVR0TAQH/
'' SIG '' BAgwBgEB/wIBADAfBgNVHSMEGDAWgBTdBAkHovV6fVJT
'' SIG '' EpKV7jiAJQ2mWTCBgwYIKwYBBQUHAQEEdzB1MFEGCCsG
'' SIG '' AQUFBzAChkVodHRwOi8vd3d3LnNzbC5jb20vcmVwb3Np
'' SIG '' dG9yeS9TU0xjb21Sb290Q2VydGlmaWNhdGlvbkF1dGhv
'' SIG '' cml0eVJTQS5jcnQwIAYIKwYBBQUHMAGGFGh0dHA6Ly9v
'' SIG '' Y3Nwcy5zc2wuY29tMD8GA1UdIAQ4MDYwNAYEVR0gADAs
'' SIG '' MCoGCCsGAQUFBwIBFh5odHRwczovL3d3dy5zc2wuY29t
'' SIG '' L3JlcG9zaXRvcnkwEwYDVR0lBAwwCgYIKwYBBQUHAwgw
'' SIG '' OwYDVR0fBDQwMjAwoC6gLIYqaHR0cDovL2NybHMuc3Ns
'' SIG '' LmNvbS9zc2wuY29tLXJzYS1Sb290Q0EuY3JsMB0GA1Ud
'' SIG '' DgQWBBQMnRAljpqnG5mHQ88IfuG9gZD0zzAOBgNVHQ8B
'' SIG '' Af8EBAMCAYYwDQYJKoZIhvcNAQELBQADggIBAJIZdQ2m
'' SIG '' WkLPGQfZ8vyU+sCb8BXpRJZaL3Ez3VDlE3uZk3cPxPty
'' SIG '' bVfLuqaci0W6SB22JTMttCiQMnIVOsXWnIuAbD/aFTcU
'' SIG '' kTLBI3xys+wEajzXaXJYWACDS47BRjDtYlDW14gLJxf8
'' SIG '' W6DQoH3jHDGGy8kGJFOlDKG7/YrK7UGfHtBAEDVe6lyZ
'' SIG '' +FtCsrk7dD/IiL/+Q3Q6SFASJLQ2XI89ihFugdYL77Ci
'' SIG '' DNXrI2MFspQGswXEAGpHuaQDTHUp/LdR3TyrIsLlnzoL
'' SIG '' skUGswF/KF8+kpWUiKJNC4rPWtNrxlbXYRGgdEdx8SMj
'' SIG '' UTDClldcrknlFxbqHsVmr9xkT2QtFmG+dEq1v5fsIK0v
'' SIG '' HaHrWjMMmaJ9i+4qGJSD0stYfQ6v0PddT7EpGxGd867A
'' SIG '' da6FZyHwbuQSadMb0K0P0OC2r7rwqBUe0BaMqTa6LWzW
'' SIG '' ItgBjGcObXeMxmbQqlEz2YtAcErkZvh0WABDDE4U8GyV
'' SIG '' /32FdaAvJgTfe9MiL2nSBioYe/g5mHUSWAay/Ip1RQmQ
'' SIG '' CvmF9sNfqlhJwkjy/1U1ibUkTIUBX3HgymyQvqQTZLLy
'' SIG '' s6pL2tCdWcjI9YuLw30rgZm8+K387L7ycUvqrmQ3ZJlu
'' SIG '' jHl3r1hgV76s3WwMPgKk1bAEFMj+rRXimSC+Ev30hXZd
'' SIG '' qyMdl/il5Ksd0vhGMYICWDCCAlQCAQEwgYcwczELMAkG
'' SIG '' A1UEBhMCVVMxDjAMBgNVBAgMBVRleGFzMRAwDgYDVQQH
'' SIG '' DAdIb3VzdG9uMREwDwYDVQQKDAhTU0wgQ29ycDEvMC0G
'' SIG '' A1UEAwwmU1NMLmNvbSBUaW1lc3RhbXBpbmcgSXNzdWlu
'' SIG '' ZyBSU0EgQ0EgUjECEFparOgaNW60YoaNV33gPccwCwYJ
'' SIG '' YIZIAWUDBAIBoIIBYTAaBgkqhkiG9w0BCQMxDQYLKoZI
'' SIG '' hvcNAQkQAQQwHAYJKoZIhvcNAQkFMQ8XDTI0MDUxODE0
'' SIG '' MzY1MFowKAYJKoZIhvcNAQk0MRswGTALBglghkgBZQME
'' SIG '' AgGhCgYIKoZIzj0EAwIwLwYJKoZIhvcNAQkEMSIEINV/
'' SIG '' Rg+8ZCEN+b9RPi3IhDWKM4lSZqWVwMX2pJMcMppmMIHJ
'' SIG '' BgsqhkiG9w0BCRACLzGBuTCBtjCBszCBsAQgnXF/jcI3
'' SIG '' ZarOXkqw4fV115oX1Bzu2P2v7wP9Pb2JR+cwgYswd6R1
'' SIG '' MHMxCzAJBgNVBAYTAlVTMQ4wDAYDVQQIDAVUZXhhczEQ
'' SIG '' MA4GA1UEBwwHSG91c3RvbjERMA8GA1UECgwIU1NMIENv
'' SIG '' cnAxLzAtBgNVBAMMJlNTTC5jb20gVGltZXN0YW1waW5n
'' SIG '' IElzc3VpbmcgUlNBIENBIFIxAhBaWqzoGjVutGKGjVd9
'' SIG '' 4D3HMAoGCCqGSM49BAMCBEcwRQIgDjmotLVxrUKccSln
'' SIG '' x/RyMqsr1FC4n0N3hoKMLtLdlG8CIQCx95PRoUQuLuD2
'' SIG '' W+HJEK2ZCDeYHuAh/2W4CkWANL6+2Q==
'' SIG '' End signature block
